## frown 0.6.1

=== Makefile ===
###############################################################################
#                                                                             #
#   Frown --- An LALR(k) parser generator for Haskell 98                      #
#   Copyright (C) 2001-2005 Ralf Hinze                                        #
#                                                                             #
#   This program is free software; you can redistribute it and/or modify      #
#   it under the terms of the GNU General Public License (version 2) as       #
#   published by the Free Software Foundation.                                #
#                                                                             #
#   This program is distributed in the hope that it will be useful,           #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#   GNU General Public License for more details.                              #
#                                                                             #
#   You should have received a copy of the GNU General Public License         #
#   along with this program; see the file COPYING.  If not, write to          #
#   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,          #
#   Boston, MA 02111-1307, USA.                                               #
#                                                                             #
#   Contact information                                                       #
#   Email:      Ralf Hinze <ralf@cs.uni-bonn.de>                              #
#   Homepage:   http://www.informatik.uni-bonn.de/~ralf/                      #
#   Paper mail: Dr. Ralf Hinze                                                #
#               Institut fr Informatik III                                   #
#               Universitt Bonn                                              #
#               Rmerstrae 164                                               #
#               53117 Bonn, Germany                                           #
#                                                                             #
###############################################################################

#-----------------------------------------------------------------------------
# directories and files

export version	:= 0.6

export PREFIX	:= /usr/local
export bin      := $(PREFIX)/bin
export doc	:= $(PREFIX)/share/doc/frown-$(version)

main		:= frown
sources         := $(wildcard *.lhs)

#-----------------------------------------------------------------------------
# commands

hc		:= ghc

#-----------------------------------------------------------------------------
# main target

$(main) : $(sources) GParser2.hs
ifeq ($(hc),nhc98)
	hmake -nhc98 -98 +CTS -H32M -CTS -ILib -PLib Main
	mv Main $(main)
else
ifeq ($(hc),ghc)
	$(hc) --make -O2 -iLib -LLib -o $(main) Main.lhs
else
	ghc --make -Wall -O2 -package util -package rh -o $(main) Main.lhs
endif
endif
#	strip $(main)

#-----------------------------------------------------------------------------
# rules

.PHONY : test man install all clean distclean

test: $(main)
	cd Examples && $(MAKE) test

man:
	cd Manual && $(MAKE) man

install: $(main)
	cp $(main) $(bin)
	cd Manual && $(MAKE) install

all:
	$(MAKE) install
	$(MAKE) test
	$(MAKE) man

clean:
	@rm -f *~ *.o *.hi Lib/*.o Lib/*.hi
	cd Examples && $(MAKE) clean
	cd Manual   && $(MAKE) clean

distclean: clean
	@rm -f *.hs[0-9]*
	@rm -f frown
	cd Examples && $(MAKE) distclean
	cd Manual   && $(MAKE) distclean

=== Examples/Makefile ===
###############################################################################
#                                                                             #
#   Frown --- An LALR(k) parser generator for Haskell 98                      #
#   Copyright (C) 2001-2005 Ralf Hinze                                        #
#                                                                             #
#   This program is free software; you can redistribute it and/or modify      #
#   it under the terms of the GNU General Public License (version 2) as       #
#   published by the Free Software Foundation.                                #
#                                                                             #
#   This program is distributed in the hope that it will be useful,           #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#   GNU General Public License for more details.                              #
#                                                                             #
#   You should have received a copy of the GNU General Public License         #
#   along with this program; see the file COPYING.  If not, write to          #
#   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,          #
#   Boston, MA 02111-1307, USA.                                               #
#                                                                             #
#   Contact information                                                       #
#   Email:      Ralf Hinze <ralf@cs.uni-bonn.de>                              #
#   Homepage:   http://www.informatik.uni-bonn.de/~ralf/                      #
#   Paper mail: Dr. Ralf Hinze                                                #
#               Institut fr Informatik III                                   #
#               Universitt Bonn                                              #
#               Rmerstrae 164                                               #
#               53117 Bonn, Germany                                           #
#                                                                             #
###############################################################################

.PHONY: test clean distclean

test-frown: TestFrown.lhs
ifeq ($(hc),nhc98)
	hmake -nhc98 -98 +CTS -H32M -CTS TestFrown
	mv TestFrown test-frown
else
	ghc --make -o test-frown TestFrown.lhs
endif

test: test-frown
	@echo "**** testing small grammars"
	./test-frown
	@echo "**** testing example grammars"
	cd ../Manual/Examples && $(MAKE) test
	@echo "**** testing Haskell parser"
	cd Haskell && $(MAKE) test

clean:
	@rm -f *.o *.hi
	cd Haskell && $(MAKE) clean

distclean: clean
	@rm -f *.hs*
	@rm -f test-frown
	cd Haskell && $(MAKE) distclean

=== Manual/Makefile ===
###############################################################################
#                                                                             #
#   Frown --- An LALR(k) parser generator for Haskell 98                      #
#   Copyright (C) 2001-2005 Ralf Hinze                                        #
#                                                                             #
#   This program is free software; you can redistribute it and/or modify      #
#   it under the terms of the GNU General Public License (version 2) as       #
#   published by the Free Software Foundation.                                #
#                                                                             #
#   This program is distributed in the hope that it will be useful,           #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#   GNU General Public License for more details.                              #
#                                                                             #
#   You should have received a copy of the GNU General Public License         #
#   along with this program; see the file COPYING.  If not, write to          #
#   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,          #
#   Boston, MA 02111-1307, USA.                                               #
#                                                                             #
#   Contact information                                                       #
#   Email:      Ralf Hinze <ralf@cs.uni-bonn.de>                              #
#   Homepage:   http://www.informatik.uni-bonn.de/~ralf/                      #
#   Paper mail: Dr. Ralf Hinze                                                #
#               Institut fr Informatik III                                   #
#               Universitt Bonn                                              #
#               Rmerstrae 164                                               #
#               53117 Bonn, Germany                                           #
#                                                                             #
###############################################################################

#-----------------------------------------------------------------------------
# directories and files

file		:= Manual
sources         := $(Examples/wildcard *.lg)
sessions	:= $(sources:.lg=.session)

#-----------------------------------------------------------------------------
# commands

ghc		:= ghc
ghcflags	:= -Wall -O
flags		:= --poly
spell           := ispell -d british -t -l -p

#-----------------------------------------------------------------------------
# pattern rules

%.tex : %.lhs %.fmt $(sessions)
	lhs2TeX $(flags) $< > $@

%.ps : %.dvi
	dvips -o $@ $<

%.pdf : %.dvi
	dvipdfm $<

%.hi : %.o
	@:

%.out : %.lg %.in
	Examples/test-frown --generate $<

%.session : %.out
	Examples/sessions $<

#-----------------------------------------------------------------------------
# rules

.PHONY 	: man examples edit xdvi gv acro print spell spellupdate links clean distclean

man: $(file).ps $(file).pdf html

install: man
	mkdir -p $(doc)
	cp $(file).ps $(doc)
	cp $(file).pdf $(doc)
	cp -r html $(doc)

edit :
	xemacs $(file).fmt $(file).lhs &

examples:
	cd Examples && $(MAKE) man

# $(file).dvi depends on $(file).lhs rather than $(file).tex, so that
# it is not generated when $(file).tex is removed in the distribution.

$(file).dvi : $(file).lhs $(file).fmt $(sessions)
	$(MAKE) $(file).tex
	latex $(file)
	bibtex $(file)
	latex $(file)
	latex $(file)
	latex $(file)

xdvi : $(file).dvi
	xdvi -s 6 $(file).dvi &

gv : $(file).ps
	gv -spartan $(file).ps &

acro : $(file).pdf
	/opt/Acrobat7/acroread $(file).pdf &

html: $(file).lhs $(file).fmt $(sessions)
	lhs2TeX --math $(file).lhs > $(file).tex
	latex $(file)
	bibtex $(file)
	latex $(file)
	latex $(file)
	latex $(file)
# the above commands are only used to produce a `.bbl' file
	lhs2TeX --tt -lhtml=True $(file).lhs > $(file).tex
	hevea -fix $(file).tex
	hevea -fix $(file).tex
	hacha $(file).html
	imagen $(file)
	mkdir -p html
	mv index.html $(file).html $(file).css $(file)[0-9]*.html $(file)[0-9]*.gif *motif.gif html

spell: $(file).tex
	egrep -v '$\%' $(file).tex | $(spell) $(file).spell | sort | uniq

spellupdate: $(file).tex
	egrep -v '$\%' $(file).tex | $(spell)  $(file).spell | sort | uniq > $(file).spell

sessions: Examples/Sessions.lhs
	cd Examples && $(MAKE) sessions

test-frown: Examples/TestFrown.lhs
	cd Examples && $(MAKE) test-frown

links:
	ln -s $(HOME)/local/abbr.bib
	ln -s $(HOME)/local/rh.bib
	ln -s $(HOME)/local/lhs2TeX.fmt
	ln -s $(HOME)/local/lhs2TeX.sty
	ln -s $(HOME)/local/FuncMP.mp

clean:
	@rm -f *~ *.aux *.bbl *.blg *.log *.toc *.out
	@rm -f $(file).tex $(file).image.tex *.mpx
	cd Examples && $(MAKE) clean

distclean : clean
	@rm -f abbr.bib rh.bib lhs2TeX.fmt lhs2TeX.sty FuncMP.mp

=== Manual/Examples/Makefile ===
.PHONY: test man clean

sources         := $(wildcard *.lg)
sessions	:= $(sources:.lg=.session)

#-----------------------------------------------------------------------------
# pattern rules

%.out : %.lg %.in test-frown
	./test-frown --generate $<

%.session : %.out sessions
	./sessions $<

#-----------------------------------------------------------------------------
# main target

all: $(sessions)

sessions: Sessions.lhs
ifeq ($(hc),nhc98)
	hmake -nhc98 -98 +CTS -H32M -CTS Sessions
	mv Sessions sessions
else
	ghc --make -o sessions Sessions.lhs
endif

# Note: all grammar files must be listed in `TestFrown.lhs'.

test-frown: TestFrown.lhs
ifeq ($(hc),nhc98)
	hmake -nhc98 -98 +CTS -H32M -CTS TestFrown
	mv TestFrown test-frown
else
	ghc --make -o test-frown TestFrown.lhs
endif

test: test-frown
	@echo "**** testing small grammars"
	@./test-frown

man: $(sessions)

clean:
	@rm -f *.hs*
	@rm -f *.o *.hi test-frown sessions

=== debian/changelog ===
frown (0.6.1-14) unstable; urgency=low

  * s/^ ,$/^ .$/ in description (Closes: #675088, #675084)
  * Bump standards version, no change
  * Enable compat level 9

 -- Joachim Breitner <nomeata@debian.org>  Fri, 24 May 2013 12:49:43 +0200

frown (0.6.1-13) unstable; urgency=low

  * Extend TeX build-dependencies (Closes: #669547)

 -- Joachim Breitner <nomeata@debian.org>  Fri, 20 Apr 2012 21:25:24 +0200

frown (0.6.1-12) unstable; urgency=low

  * GHC 7.4.1 compatibility, Closes: #643120, I hope. 
  * Debian compat level 7, for debian/clean

 -- Joachim Breitner <nomeata@debian.org>  Thu, 15 Mar 2012 14:24:47 +0100

frown (0.6.1-11.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "OOM on compiling any remotely valid grammer" fix logic error in
    debian/patches/07_no-n-plus-k-pattern (Closes: #650808)

 -- Helmut Grohne <helmut@subdivi.de>  Wed, 07 Dec 2011 17:35:30 +0100

frown (0.6.1-11) unstable; urgency=low

  [ Marco Silva ]
  * Use ghc instead of ghc6

  [ Joachim Breitner ]
  * Desurgar n+k patterns, not supported by ghc any more (Closes: #628317)

 -- Joachim Breitner <nomeata@debian.org>  Thu, 02 Jun 2011 20:33:57 +0200

frown (0.6.1-10) unstable; urgency=low

  * Use source format 3.0 (quilt).
  * Fix "Package should be arch all" changing Architecture: to all
    (Closes: #517603)
  * debian/control: Addopt for the Debian Haskell Group.
  * Remove old upstream homepage.
  * debian/control: Bump Standards-Version to 3.8.4, no changes needed.
  * Remove control.in.
  * Fix "FTBFS on kfreebsd-amd64: lhs2TeX: ./Manual.lhs: hGetContents:
    invalid argument (Invalid or incomplete multibyte or wide
    character)" including patch to change the encoding to UTF-8
    (Closes: #570868)
  * debian/copyright: Use versioned file in common-licenses.

 -- Marco Túlio Gontijo e Silva <marcot@debian.org>  Fri, 05 Mar 2010 22:10:35 -0300

frown (0.6.1-9) unstable; urgency=low

  * debian/control:
    - Drop all build dependencies on tetex packages as tetex is removed.
    - Bump Standards-Version to 3.8.0
  * debian/frown-doc.doc-base:
    - Change the section from Programming to Programming/Haskell as
      suggested by the doc-base manual.
  * debian/README.source: Added.

 -- Arjan Oosting <arjan@debian.org>  Mon, 07 Jul 2008 09:36:42 +0200

frown (0.6.1-8) unstable; urgency=low

  * Fix lintian warnings:
    - Replace apps/devel section with Programming section to fix lintian
      warning "doc-base-unknown-section frown-guide:6 apps/devel."
    - Split of the documentation into a separate frown-doc package to fix
      lintian warning "arch-dep-package-has-big-usr-share 1648kB 52%"
  * debian/control:
    - Let the Vcs-* fields point to the trunk branch.
    - Add doc-base to the Suggests of frown-doc.

 -- Arjan Oosting <arjan@debian.org>  Sun, 16 Mar 2008 22:11:28 +0100

frown (0.6.1-7) unstable; urgency=low

  * debian/control:
    - Replace XS-Vcs-* fields with the new official Vcs-* fields.
    - Add Homepage field.
    - Bump Standards-Version to 3.7.3. No changes needed.

 -- Arjan Oosting <arjan@debian.org>  Tue, 08 Jan 2008 07:12:51 +0100

frown (0.6.1-6) unstable; urgency=low

  * debian/control:
    - Add XS-Vcs-Browser field.
    - Change build dependencies to prefer to build against texlive instead
      of tetex.
  * debian/rules: enclose paths in double quotes because directories can
    contain spaces.

 -- Arjan Oosting <arjan@debian.org>  Fri, 13 Apr 2007 09:37:14 +0200

frown (0.6.1-5) unstable; urgency=low

  * Make frown Architecture: any as ghc6 is available on all architectures
    now.
  * Stop using update-haskell-control and $ghc6_* variables, as it is not
    necessary and not using it simplifies the work for porters and for me.

 -- Arjan Oosting <arjan@debian.org>  Sat, 13 Jan 2007 10:25:59 +0100

frown (0.6.1-4) unstable; urgency=low

  * First upload to Debian archive. (Closes:  #336978).
  * debian/control.in.in: 
    - change maintainer email address.
    - rename XS-X-Vcs-Svn field to XS-Vcs-Svn

 -- Arjan Oosting <arjan@debian.org>  Tue, 17 Oct 2006 04:01:36 +0200

frown (0.6.1-3) unstable; urgency=low

  * debian/control.in.in: 
    - ident Homepage field with two spaces. (Thanks James Westby).
    - add ppc64 to the list of supported arches as ghc6 is available on
      ppc64 as well. 
    - add XS-X-Vcs-Svn field pointing to subversion archive which contains
      this package.
    - document some of the differences with happy in the long description. 
  * debian/compat: switch to debhelper 5.
  * debian/rules: switch from simple-patchsys to dpatch.

 -- Arjan Oosting <arjanoosting@home.nl>  Thu, 28 Sep 2006 01:53:20 +0200

frown (0.6.1-2) unstable; urgency=low

  * debian/control.in.in: bump Standards-Version to 3.7.2. No changes
    needed.
  * debian/copyright: add Debian packaging copyright.
  * debian/frown.doc-base: added entry for PDF format.
  * debian/frown.install: include the examples from the QuickStart,
    Manual/Examples and Examples directories. 
  * debian/patches/04_manual-typos.patch: add missing backslashes before
    LaTeX ldots command. 
  * debian/patches/05_only-build-pdf.patch: don't build and install the
    manual in PS format.
  * debian/rules: don't compress the pdf documentation.

 -- Arjan Oosting <arjanoosting@home.nl>  Wed, 17 May 2006 14:46:09 +0200

frown (0.6.1-1) unstable; urgency=low

  * New upstream release.
  * debian/rules:
    - rebuild manual during build.
    - don't run tests during build yet.
  * added patches:
    - 01imagen-creates-png-files.patch: imagen generates png files
      instead of gif files on a Debian system.
    - 02ignore-hugs-version-in-test-frown.patch: ignore the version
      header of Hugs in the output of the test cases.
    - 03update-empty.out.patch: update the Empty example to match
      the output given by the version of Hugs in unstable.
  * debian/frown.doc-base: added doc-base support.

 -- Arjan Oosting <arjanoosting@home.nl>  Tue, 17 Jan 2006 22:29:35 +0100



=== debian/control ===
Source: frown
Section: devel
Priority: optional
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Marco Túlio Gontijo e Silva <marcot@debian.org>
Build-Depends: cdbs, debhelper (>= 9), ghc,
 hevea, lhs2tex, texlive-latex-base, texlive-latex-recommended,
 texlive-latex-extra, texlive-math-extra, texlive-generic-recommended
Standards-Version: 3.9.4
Vcs-Darcs: http://darcs.debian.org/pkg-haskell/frown
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/frown

Package: frown
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: frown-doc (= ${source:Version})
Description: LALR(k) parser generator for Haskell 98
 Frown is inspired by the parser generator Happy and uses a syntax
 quite simular as the syntax used by Happy. Happy only handles LALR(1)
 grammars while Frown can use more extensive LALR(k) grammars and the
 parsers generated by Frown are also faster than the parsers generated
 by Happy.    
 .
 The salient features of Frown are:
   - The generated parsers are time and space efficient. On the
     downside, the parsers are quite large.
   - Frown generates four different types of parsers. As a common
     characteristic, the parsers are genuinely functional 
     (ie 'table-free'); the states of the underlying LR automaton are
     encoded as mutually recursive functions. Three output formats use
     a typed stack representation, one format due to Ross Paterson
     (code=stackless) works even without a stack.
   - Encoding states as functions means that each state can be treated
     individually as opposed to a table driven-approach, which
     necessitates a uniform treatment of states. For instance,
     look-ahead is only used when necessary to resolve conflicts.
   - Frown comes with debugging and tracing facilities; the standard
     output format due to Doaitse Swierstra (code=standard) may be
     useful for teaching LR parsing.
   - Common grammatical patterns such as repetition of symbols can be
     captured using rule schemata. There are several predefined rule
     schemata.
   - Terminal symbols are arbitrary variable-free Haskell patterns or
     guards. Both terminal and nonterminal symbols may have an
     arbitrary number of synthesized attributes.
   - Frown comes with extensive documentation; several example grammars
     are included. 
 .
 Furthermore, Frown supports the use of monadic lexers, monadic
 semantic actions, precedences and associativity, the generation of
 backtracking parsers, multiple start symbols, error reporting and a
 weak form of error correction.

Package: frown-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: doc-base
Description: Manual of the frown parser generator for Haskell 98
 The manual and examples of the frown LALR(k) parser generator.
 .
 Frown is inspired by the parser generator Happy and uses a syntax
 quite simular as the syntax used by Happy. Happy only handles LALR(1)
 grammars while Frown can use more extensive LALR(k) grammars and the
 parsers generated by Frown are also faster than the parsers generated
 by Happy.    
 .
 The salient features of Frown are:
   - The generated parsers are time and space efficient. On the
     downside, the parsers are quite large.
   - Frown generates four different types of parsers. As a common
     characteristic, the parsers are genuinely functional 
     (ie 'table-free'); the states of the underlying LR automaton are
     encoded as mutually recursive functions. Three output formats use
     a typed stack representation, one format due to Ross Paterson
     (code=stackless) works even without a stack.
   - Encoding states as functions means that each state can be treated
     individually as opposed to a table driven-approach, which
     necessitates a uniform treatment of states. For instance,
     look-ahead is only used when necessary to resolve conflicts.
   - Frown comes with debugging and tracing facilities; the standard
     output format due to Doaitse Swierstra (code=standard) may be
     useful for teaching LR parsing.
   - Common grammatical patterns such as repetition of symbols can be
     captured using rule schemata. There are several predefined rule
     schemata.
   - Terminal symbols are arbitrary variable-free Haskell patterns or
     guards. Both terminal and nonterminal symbols may have an
     arbitrary number of synthesized attributes.
   - Frown comes with extensive documentation; several example grammars
     are included. 
 .
 Furthermore, Frown supports the use of monadic lexers, monadic
 semantic actions, precedences and associativity, the generation of
 backtracking parsers, multiple start symbols, error reporting and a
 weak form of error correction.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_COMPRESS_EXCLUDE    = .pdf
DEB_MAKE_BUILD_TARGET   = frown man
DEB_MAKE_INSTALL_TARGET = install PREFIX="$(DEB_DESTDIR)usr" doc="$(DEB_DESTDIR)usr/share/doc/frown-doc"
DEB_MAKE_CLEAN_TARGET   = distclean
# DEB_MAKE_CHECK_TARGET   = test 

clean::
	dh_testdir
	rm -f Manual/Manual.pdf Manual/Manual.ps Manual/Manual.dvi Manual/Manual.tex
	rm -rf Manual/html Manual/Manual[0-9]*.png  Manual/*_motif.gif

common-install-prehook-arch::
	dh_testdir
	mkdir -p debian/tmp/usr/bin

common-install-prehook-indep::
	dh_testdir
	mkdir -p debian/tmp/usr/bin

binary-post-install/frown::
	dh_testdir
	rm debian/frown/usr/share/doc/frown/README

binary-post-install/frown-doc::
	rm debian/frown-doc/usr/share/doc/frown-doc/README
	rm debian/frown-doc/usr/share/doc/frown-doc/examples/manual/Sessions.lhs
	rm debian/frown-doc/usr/share/doc/frown-doc/examples/manual/TestFrown.lhs

.PHONY: update-debian-control

=== debian/watch ===
# IGNORE: dead upstream

## frown 0.6.2.3

=== Manual/Makefile ===
--- 
+++ 
@@ -21,9 +21,9 @@
 #   Email:      Ralf Hinze <ralf@cs.uni-bonn.de>                              #
 #   Homepage:   http://www.informatik.uni-bonn.de/~ralf/                      #
 #   Paper mail: Dr. Ralf Hinze                                                #
-#               Institut fr Informatik III                                   #
-#               Universitt Bonn                                              #
-#               Rmerstrae 164                                               #
+#               Institut für Informatik III                                   #
+#               Universität Bonn                                              #
+#               Römerstraße 164                                               #
 #               53117 Bonn, Germany                                           #
 #                                                                             #
 ###############################################################################
@@ -117,7 +117,7 @@
 	hacha $(file).html
 	imagen $(file)
 	mkdir -p html
-	mv index.html $(file).html $(file).css $(file)[0-9]*.html $(file)[0-9]*.gif *motif.gif html
+	mv index.html $(file).html $(file).css $(file)[0-9]*.html $(file)[0-9]*.png *motif.gif html
 
 spell: $(file).tex
 	egrep -v '$\%' $(file).tex | $(spell) $(file).spell | sort | uniq

=== Examples/Haskell/Makefile ===
ifeq ($(hc),nhc98)
main :=	hmake -nhc -c -M120M -K32M +CTS -H32M -CTS -ILib -LLib Main; mv Main a.out
else
ifeq ($(hc),ghc)
#main :=	ghc --make -iLib -LLib Main.lhs +RTS -c -M120M
main :=	ghc --make -iLib -LLib Main.lhs
else
#main :=	ghc --make -package text -package util Main.lhs +RTS -c -M120M
main :=	ghc --make -package text -package util Main.lhs
endif
endif

define run
	$(main)
	./a.out Input/Big.hs | diff Input/Big.out -
	./a.out Input/Generate.hs | diff Input/Generate.out -	
	./a.out Test/Small1.hs | diff Test/Small1.out -	
	./a.out Test/Small2.hs | diff Test/Small2.out -	
	./a.out Test/Small3.hs | diff Test/Small3.out -	
	./a.out Test/Small4.hs | diff Test/Small4.out -	
	./a.out Test/Small5.hs | diff Test/Small5.out -	
	./a.out Test/Small6.hs | diff Test/Small6.out -	
endef

INPUTS          := $(wildcard Input/*.hs)
HC_OPTIONS	= -O
FROWN_OPTIONS	= --optimize

.PHONY: test clean distclean

test:
	@echo "*** standard"
	../../frown --lexer --expected --signature $(FROWN_OPTIONS) --code=standard HsParser.lg
	$(run)
	@echo "*** compact"
	../../frown --lexer --expected --signature $(FROWN_OPTIONS) --code=compact HsParser.lg
	$(run)
	@echo "*** stackless"
	../../frown --lexer --expected --signature $(FROWN_OPTIONS) --code=stackless HsParser.lg
	$(run)
#	@echo "*** gvstack"
#	../../frown --lexer --expected --signature $(FROWN_OPTIONS) --code=gvstack HsParser.lg
#	$(run)

clean:
	@rm -f *~ *.o *.hi Lib/*.o Lib/*.hi

distclean: clean
	@rm -f HsParser.hs* a.out

=== debian/changelog ===
frown (0.6.2.3-4) unstable; urgency=medium

  * Upload to unstable as part of GHC 8 transition.

 -- Clint Adams <clint@debian.org>  Thu, 27 Oct 2016 18:32:16 -0400

frown (0.6.2.3-3) experimental; urgency=medium

  * Temporarily build-depend on ghc 8.

 -- Clint Adams <clint@debian.org>  Sun, 16 Oct 2016 12:44:24 -0400

frown (0.6.2.3-2) unstable; urgency=medium

  [ Dmitry Bogatov ]
  * Use secure (https) uri in Vcs-Git field in 'debian/control'
  * Bump standards version to 3.9.8 (no changes needed)
  * Convert `debian/copyright' to dep5 format

  [ Ilias Tsitsimpis ]
  * Propagate the changes from experimental (0.6.2.3-1) to unstable
  * Drop the 04_manual-typos patch.
    The above patch produces the wrong output by trying to add
    backslashes where they are not needed.
  * Disable dbgsym generation.
    GHC cannot produce debugging symbols, so the dbgsym package ends
    up being empty.
  * Add patch 'fix-pdf-generation'.
    Due to an error in the way Makefile produces the doc files, the
    Manual.pdf file was not generated correctly. This has been fixed
    by patching the Makefile.
  * Update d/copyright file with missing copyright notices.
    Some files under 'Examples/Haskell' directory are distributed under
    the Glasgow Haskell Compiler License.

 -- Ilias Tsitsimpis <i.tsitsimpis@gmail.com>  Sun, 22 May 2016 14:40:46 +0300

frown (0.6.2.3-1) experimental; urgency=medium

  * New upstream release.

 -- Joachim Breitner <nomeata@debian.org>  Wed, 16 Mar 2016 10:52:50 +0100

frown (0.6.2.2-1) experimental; urgency=medium

  * Upgrade to hackage release of frown.

 -- Joachim Breitner <nomeata@debian.org>  Sun, 07 Feb 2016 13:03:49 +0100

frown (0.6.1-14.1) experimental; urgency=medium

  [ Helmut Grohne ]
  * Mark frown as Multi-Arch:foreign.

  [ Joachim Breitner ]
  * Bump standards-version to 3.9.6

 -- Joachim Breitner <nomeata@debian.org>  Thu, 20 Aug 2015 10:26:52 +0200

=== debian/control ===
Source: frown
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders:
 Joachim Breitner <nomeata@debian.org>,
Priority: extra
Section: haskell
Build-Depends:
 cdbs,
 debhelper (>= 9),
 ghc (>= 8),
 haskell-devscripts (>= 0.13),
 hevea,
 lhs2tex,
 texlive-generic-recommended,
 texlive-latex-extra,
Standards-Version: 3.9.8
Homepage: http://hackage.haskell.org/package/frown
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/tree/p/frown
Vcs-Git: https://anonscm.debian.org/git/pkg-haskell/DHG_packages.git
X-Description: LALR(k) parser generator
 Frown is an LALR(k) parser generator for Haskell 98 written in Haskell 98.
 .
 Its salient features are:
    -  The generated parsers are time and space efficient. On the downside, the
       parsers are quite large.
    -  Frown generates four different types of parsers. as a common
       characteristic, the parsers are genuinely functional (ie ‘table-free’);
       the states of the underlying LR automaton are encoded as mutually
       recursive functions. Three output formats use a typed stack
       representation, and one format due to Ross Paterson (code=stackless)
       works even without a stack.
    -  Encoding states as functions means that each state can be treated
       individually as opposed to a table-driven approach, which necessitates a
       uniform treatment of states. For instance, look-ahead is only used when
       necessary to resolve conflicts.
    -  Frown comes with debugging and tracing facilities; the standard output
       format due to Doaitse Swierstra (code=standard) may be useful for
       teaching LR parsing.
    -  Common grammatical patterns such as repetition of symbols can be
       captured using rule schemata. There are several predefined rule
       schemata.
    -  Terminal symbols are arbitrary variable-free Haskell patterns or guards.
       Both terminal and nonterminal symbols may have an arbitrary number of
       synthesized attributes.
    -  Frown comes with extensive documentation; several example grammars are
       included. Furthermore, Frown supports the use of monadic lexers, monadic
       semantic actions, precedences, and associativity, the generation of
       backtracking parsers, multiple start symbols, error reporting, and a
       weak form of error correction.

Package: frown
Architecture: any
Section: misc
Depends:
 ${haskell:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 frown-doc (= ${source:Version}),
 ${haskell:Recommends},
Suggests:
 ${haskell:Suggests},
Conflicts:
 ${haskell:Conflicts},
Provides:
 ${haskell:Provides},
Multi-Arch: foreign
Description: ${haskell:ShortDescription}
 ${haskell:LongDescription}

Package: frown-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 doc-base,
Description: ${haskell:ShortDescription} -- documentation
 ${haskell:LongDescription}

=== debian/rules ===
#!/usr/bin/make -f

DEB_CABAL_PACKAGE = frown
DEB_DEFAULT_COMPILER = ghc

# GHC cannot produce debugging symbols so the dbgsym package
# ends up being empty, so disable generating it.
DEB_DH_STRIP_ARGS := --no-automatic-dbgsym

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk

build/frown:: build-ghc-stamp

clean::
	make -C Manual clean
	rm -rf Manual/html

build/frown-doc::
	make -C Manual

binary-fixup/frown-doc::
	chmod -R a-x debian/frown-doc/usr/share/doc/frown-doc/examples
	chmod -R a+X debian/frown-doc/usr/share/doc/frown-doc/examples

=== debian/watch ===
version=3
http://hackage.haskell.org/package/frown/distro-monitor .*-([0-9\.]+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
